"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var apply_events_exports = {};
__export(apply_events_exports, {
  applyEvents: () => applyEvents
});
module.exports = __toCommonJS(apply_events_exports);
const applyEventAction = (data, action) => {
  let changed = false;
  switch (action.action) {
    case "addTag": {
      if (!data.tags) {
        data.tags = [];
      }
      if (data.tags.indexOf(action.value) < 0) {
        data.tags.push(action.value);
        changed = true;
      }
      break;
    }
    case "removeTag": {
      if (!data.tags || !data.tags.length) {
        return false;
      }
      const index = data.tags.indexOf(action.value);
      if (index >= 0) {
        data.tags.splice(index, 1);
        changed = true;
      }
      break;
    }
  }
  return changed;
};
const isValidEvent = (event) => {
  var _a, _b;
  return event.type == "userAction" && ((_a = event.targetIds) == null ? void 0 : _a.length) && ((_b = event.actions) == null ? void 0 : _b.length);
};
const applyEventDate = (entry, event) => {
  if (!event.date) {
    return;
  } else if (!entry.updated || entry.updated < event.date) {
    entry.updated = event.date;
  }
};
const idMapReducer = (result, entry) => {
  const id = entry.id;
  if (!result[id]) {
    result[entry.id] = [entry];
  } else {
    result[id].push(entry);
  }
  return result;
};
const flattenReducer = (result, entry) => {
  result.push(...entry);
  return result;
};
const applyEvents = (entries, events) => {
  const id2Entries = entries.reduce(idMapReducer, {});
  const changedEntries = [];
  events.filter(isValidEvent).forEach((event) => {
    const eventId = event.id;
    const targetEntries = event.targetIds.filter((entryId) => {
      var _a;
      return (_a = id2Entries[entryId]) == null ? void 0 : _a.length;
    }).map((entryId) => id2Entries[entryId]).reduce(flattenReducer, []).filter((entry) => !entry.appliedEventIds || entry.appliedEventIds.indexOf(eventId) < 0);
    targetEntries.forEach((entry) => {
      let changed = false;
      event.actions.forEach((action) => {
        changed = applyEventAction(entry, action) || changed;
      });
      if (!entry.appliedEventIds) {
        entry.appliedEventIds = [];
      }
      entry.appliedEventIds.push(event.id);
      if (changed) {
        if (!changedEntries.includes(entry)) {
          changedEntries.push(entry);
        }
        applyEventDate(entry, event);
      }
    });
  });
  return changedEntries;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  applyEvents
});
//# sourceMappingURL=apply-events.js.map
