"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toI = exports.toF = exports.isNumber = void 0;
var Maybe_1 = require("./Maybe");
function isNumber(n) {
    return typeof n === "number" && isFinite(n);
}
exports.isNumber = isNumber;
function toF(n) {
    if (n == null)
        return;
    if (isNumber(n))
        return n;
    try {
        return parseFloat(String(n));
    }
    catch (_a) {
        return undefined;
    }
}
exports.toF = toF;
function toI(n) {
    return Maybe_1.map(toF(n), function (f) { return Math.round(f); });
}
exports.toI = toI;
//# sourceMappingURL=Number.js.map