"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RewriteAllTagsTask = void 0;
var _path = __importStar(require("path"));
var Array_1 = require("./Array");
var ExifToolTask_1 = require("./ExifToolTask");
var Maybe_1 = require("./Maybe");
var RewriteAllTagsTask = /** @class */ (function (_super) {
    __extends(RewriteAllTagsTask, _super);
    function RewriteAllTagsTask(args) {
        return _super.call(this, args) || this;
    }
    RewriteAllTagsTask.for = function (imgSrc, imgDest, allowMakerNoteRepair) {
        // -all= -tagsfromfile @ -all:all -unsafe -icc_profile bad.jpg
        var args = Array_1.compact([
            "-all=",
            "-tagsfromfile",
            "@",
            "-all:all",
            "-unsafe",
            "-icc_profile",
            allowMakerNoteRepair ? "-F" : undefined,
            _path.resolve(imgSrc),
            "-out",
            _path.resolve(imgDest),
        ]);
        return new RewriteAllTagsTask(args);
    };
    RewriteAllTagsTask.prototype.parse = function (data, error) {
        if (error != null && String(error).startsWith("Warning: ")) {
            throw error;
        }
        if (data.trim() !== "1 image files created") {
            throw Maybe_1.orElse(error, function () {
                return new Error(Maybe_1.orElse(data.trim().split("\n")[0], "Missing expected status message"));
            });
        }
    };
    return RewriteAllTagsTask;
}(ExifToolTask_1.ExifToolTask));
exports.RewriteAllTagsTask = RewriteAllTagsTask;
//# sourceMappingURL=RewriteAllTagsTask.js.map